Bug 1109491 - Review Request: liblbfgs - Limited-memory Broyden-Fletcher-Goldfarb-Shanno library
Summary: Review Request: liblbfgs - Limited-memory Broyden-Fletcher-Goldfarb-Shanno li...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Mukundan Ragavan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1111388
TreeView+ depends on / blocked
 
Reported: 2014-06-14 13:25 UTC by Sandro Mani
Modified: 2015-01-17 19:17 UTC (History)
2 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-06-30 23:26:50 UTC
nonamedotc: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Sandro Mani 2014-06-14 13:25:12 UTC
Spec URL: http://smani.fedorapeople.org/review/liblbfgs.spec
SRPM URL: http://smani.fedorapeople.org/review/liblbfgs-1.10-1.fc21.src.rpm
Description: Limited-memory Broyden-Fletcher-Goldfarb-Shanno library
Fedora Account System Username: smani

Comment 1 Mukundan Ragavan 2014-06-15 23:47:59 UTC
Taking this for review.

Comment 2 Mukundan Ragavan 2014-06-18 21:01:37 UTC
Should I review this now or should we wait for a couple of more days?

Comment 3 Sandro Mani 2014-06-18 21:05:53 UTC
I'd say go for it. Thanks!

Comment 4 Mukundan Ragavan 2014-06-19 22:45:37 UTC
There are a few issues to be taken care of here - 

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

---> Please use one style consistently.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[?]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

----> ??

[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "MIT/X11 (BSD like)", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in
     /home/mukundan/personal/pkgs/reviews/1109491-liblbfgs/licensecheck.txt

---> This is fine.

[x]: License file installed when any subpackage combination is installed.
[!]: %build honors applicable compiler flags or justifies otherwise.

I see -O3 being used ....

/bin/sh ../libtool --mode=compile --tag=CC gcc -DHAVE_CONFIG_H -I. -I. -I.. -I.. -I../include   -O3 -ffast-math -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches  -m64 -mtune=generic -Wall -O3 -ffast-math -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches  -m64 -mtune=generic -Wall -c -o lbfgs.lo lbfgs.c
mkdir .libs
 gcc -DHAVE_CONFIG_H -I. -I. -I.. -I.. -I../include -O3 -ffast-math -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -m64 -mtune=generic -Wall -O3 -ffast-math -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -m64 -mtune=generic -Wall -c lbfgs.c  -fPIC -DPIC -o .libs/lbfgs.o

and others ....


http://fedoraproject.org/wiki/Packaging:Guidelines#Compiler_flags


[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[?]: Development files must be in a -devel package.
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: liblbfgs-1.10-1.fc21.x86_64.rpm
          liblbfgs-devel-1.10-1.fc21.x86_64.rpm
          liblbfgs-1.10-1.fc21.src.rpm
liblbfgs-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint liblbfgs-devel liblbfgs
liblbfgs-devel.x86_64: W: no-documentation
liblbfgs.x86_64: W: unused-direct-shlib-dependency /usr/lib64/liblbfgs-1.10.so /lib64/libm.so.6

---> This needs to be checked.

2 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
liblbfgs-devel (rpmlib, GLIBC filtered):
    liblbfgs(x86-64)

liblbfgs (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libm.so.6()(64bit)
    rtld(GNU_HASH)



Provides
--------
liblbfgs-devel:
    liblbfgs-devel
    liblbfgs-devel(x86-64)

liblbfgs:
    liblbfgs
    liblbfgs(x86-64)
    liblbfgs-1.10.so()(64bit)



Unversioned so-files
--------------------
liblbfgs: /usr/lib64/liblbfgs-1.10.so

Source checksums
----------------
https://github.com/downloads/chokkan/liblbfgs/liblbfgs-1.10.tar.gz :
  CHECKSUM(SHA256) this package     : 4158ab7402b573e5c69d5f6b03c973047a91e16ca5737d3347e3af9c906868cf
  CHECKSUM(SHA256) upstream package : 4158ab7402b573e5c69d5f6b03c973047a91e16ca5737d3347e3af9c906868cf


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1109491
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 5 Mukundan Ragavan 2014-06-19 22:47:08 UTC
Mid air collission ....

Comment 6 Mukundan Ragavan 2014-06-19 22:51:09 UTC
The -O3 is defined here, as far as I can tell - 

dnl ------------------------------------------------------------------
dnl Checks for debugging mode
dnl ------------------------------------------------------------------
AC_ARG_ENABLE(
    debug,
    [AS_HELP_STRING(
        [--enable-debug],
        [build for debugging]
        )],
    [CFLAGS="-DDEBUG -O -g ${CFLAGS}"],
    [CFLAGS="-O3 -ffast-math ${CFLAGS}"]
)

Comment 7 Sandro Mani 2014-06-19 22:57:16 UTC
I'm not sure what the policy regarding the kind of shared library versioning used here is... basically we have
%{_libdir}/liblbfgs-1.10.so
and
%{_libdir}/liblbfgs.so -> %{_libdir}/liblbfgs-1.10.so

Guess it would probably best to just use the conventional so versioning.

Comment 8 Mukundan Ragavan 2014-06-19 22:58:52 UTC
(In reply to Sandro Mani from comment #7)

> Guess it would probably best to just use the conventional so versioning.

That might avoid any confusions I think.

Comment 9 Mukundan Ragavan 2014-06-19 23:01:48 UTC
Forgot to add this -

Koji build - http://koji.fedoraproject.org/koji/taskinfo?taskID=7060156

Comment 10 Sandro Mani 2014-06-19 23:12:24 UTC
Spec URL: http://smani.fedorapeople.org/review/liblbfgs.spec
SRPM URL: http://smani.fedorapeople.org/review/liblbfgs-1.10-2.fc21.src.rpm


%changelog
* Fri Jun 20 2014 Sandro Mani <manisandro@gmail.com> - 1.10-2
- $RPM_BUILD_ROOT -> %%{buildroot}
- Add liblbfgs_build.patch

Comment 11 Mukundan Ragavan 2014-06-19 23:56:06 UTC
* Patch looks fine and fixes the indicated issues.

* Package builds fine - http://koji.fedoraproject.org/koji/taskinfo?taskID=7060213

** Only one remaining issue - The rpmlint warning could also be fixed - http://fedoraproject.org/wiki/Common_Rpmlint_issues#unused-direct-shlib-dependency

Comment 12 Sandro Mani 2014-06-20 08:19:19 UTC
Spec URL: http://smani.fedorapeople.org/review/liblbfgs.spec
SRPM URL: http://smani.fedorapeople.org/review/liblbfgs-1.10-3.fc21.src.rpm

%changelog
* Fri Jun 20 2014 Sandro Mani <manisandro@gmail.com> - 1.10-3
- Add -Wl,--as-needed

Comment 13 Mukundan Ragavan 2014-06-20 13:10:48 UTC
Very nice. Package APPROVED.

Looks like everything for gmsh is nicely falling into place. :)

Comment 14 Sandro Mani 2014-06-20 13:24:56 UTC
Yeah, looks like mmg3d is the last missing piece, and possibly also a reworked freefem++ package might be nice to avoid the bundling issue. Will also look into that ;)

Thanks for the review!

New Package SCM Request
=======================
Package Name: liblbfgs
Short Description: Limited-memory Broyden-Fletcher-Goldfarb-Shanno library
Owners: smani
Branches: f20 el6 epel7
InitialCC:

Comment 15 Kevin Fenzi 2014-06-21 17:17:23 UTC
Git done (by process-git-requests).

Comment 16 Fedora Update System 2014-06-22 00:04:38 UTC
liblbfgs-1.10-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/liblbfgs-1.10-3.fc20

Comment 17 Fedora Update System 2014-06-22 23:54:40 UTC
liblbfgs-1.10-3.fc20 has been pushed to the Fedora 20 testing repository.

Comment 18 Fedora Update System 2014-06-30 23:26:50 UTC
liblbfgs-1.10-3.fc20 has been pushed to the Fedora 20 stable repository.

Comment 19 Fedora Update System 2015-01-01 21:35:41 UTC
liblbfgs-1.10-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/liblbfgs-1.10-3.el6

Comment 20 Fedora Update System 2015-01-01 21:37:58 UTC
liblbfgs-1.10-3.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/liblbfgs-1.10-3.el7

Comment 21 Fedora Update System 2015-01-17 19:16:37 UTC
liblbfgs-1.10-3.el7 has been pushed to the Fedora EPEL 7 stable repository.

Comment 22 Fedora Update System 2015-01-17 19:17:30 UTC
liblbfgs-1.10-3.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.